(define-module(ice-9 debug))
(define-public (frame-number->index n . stack)(let((stack(if(null? stack)(fluid-ref the-last-stack)(car stack))))(if(memq(quote backwards)(debug-options))n(-(stack-length stack)n 1))))
(define traced-procedures(quote()))
(define-public (trace . args)(if(null? args)(nameify traced-procedures)(begin(for-each(lambda(proc)(if(not(procedure? proc))(error "trace: Wrong type argument:" proc))(set-procedure-property! proc(quote trace)#t)(if(not(memq proc traced-procedures))(set! traced-procedures(cons proc traced-procedures))))args)(set! apply-frame-handler trace-entry)(set! exit-frame-handler trace-exit)(set! trace-level 0)(debug-enable(quote trace))(nameify args))))
(define-public (untrace . args)(if(and(null? args)(not(null? traced-procedures)))(apply untrace traced-procedures)(begin(for-each(lambda(proc)(set-procedure-property! proc(quote trace)#f)(set! traced-procedures(delq! proc traced-procedures)))args)(if(null? traced-procedures)(debug-disable(quote trace)))(nameify args))))
(define(nameify ls)(map(lambda(proc)(let((name(procedure-name proc)))(or name proc)))ls))
(define trace-level 0)
(add-hook! abort-hook(lambda()(set! trace-level 0)))
(define(trace-entry key cont tail)(if(eq?(stack-id cont)(quote repl-stack))(let((cep(current-error-port))(frame(last-stack-frame cont)))(if(not tail)(set! trace-level(+ trace-level 1)))(let indent((n trace-level))(cond((> n 1)(display "|  " cep)(indent(- n 1)))))(display-application frame cep)(newline cep))))
(define(trace-exit key cont retval)(if(eq?(stack-id cont)(quote repl-stack))(let((cep(current-error-port)))(set! trace-level(- trace-level 1))(let indent((n trace-level))(cond((> n 0)(display "|  " cep)(indent(- n 1)))))(write retval cep)(newline cep))))
(variable-set!(builtin-variable(quote debug-options))debug-options)
(debug-enable(quote debug))
(read-enable(quote positions))
