(define-module(ice-9 documentation)#:use-module(ice-9 rdelim)#:export(file-commentary module-commentary documentation-files search-documentation-files object-documentation)#:autoload(ice-9 regex)(match:suffix)#:autoload(ice-9 gumm)(module-name->catalog-entry)#:no-backtrace)
(define default-in-line-re(make-regexp "^;;; Commentary:"))
(define default-after-line-re(make-regexp "^;;; Code:"))
(define default-scrub(let((dirt(make-regexp "^(;+ |;+)")))(lambda(line)(let((m(regexp-exec dirt line)))(if m(match:suffix m)line)))))
(define (file-commentary filename . cust)(let*((n(length cust))(in-line-re(let((v(and(< 0 n)(car cust))))(cond((regexp? v)v)((string? v)(make-regexp v))(else default-in-line-re))))(after-line-re(let((v(and(< 1 n)(cadr cust))))(cond((regexp? v)v)((string? v)(make-regexp v))(else default-after-line-re))))(scrub(let((v(and(< 2 n)(caddr cust))))(cond((procedure? v)v)(else default-scrub))))(ls(list #f))(port(open-input-file filename)))(let loop((tp ls)(collect? #f))(let((line(read-delimited "\n" port)))(cond((or(eof-object? line)(and collect?(regexp-exec after-line-re line)))(close-port port)(apply string-append(cdr ls)))(collect?(set-cdr! tp(list(scrub line)"\n"))(loop(cddr tp)#t))(else(loop tp(regexp-exec in-line-re line))))))))
(define(module-commentary module-name)(or(and=>(module-name->catalog-entry module-name)(lambda(entry)(file-commentary(if(string? entry)entry(cdr(last-pair entry))))))""))
(define documentation-files(let((fn "guile-procedures.txt"))(cons(in-vicinity(%package-data-dir)(in-vicinity(version)fn))(if(file-exists? fn)(list fn)(quote())))))
(define(find-documentation name)(or-map(lambda(file)(find-documentation-in-file name file))documentation-files))
(define entry-delimiter "\f")
(define entry-start 2)
(define(find-documentation-in-file name file)(and(file-exists? file)(call-with-input-file file(lambda(port)(let*((name(symbol->string name))(len(string-length name))(min-size(+ entry-start len))(end(+ entry-start len)))(read-delimited entry-delimiter port)(let loop((entry(read-delimited entry-delimiter port)))(cond((eof-object? entry)#f)((and(>=(string-length entry)min-size)(string=?(substring entry entry-start end)name)(memq(string-ref entry end)(quote(#\space #\)))))(substring entry 1(-(string-length entry)1)))(else(loop(read-delimited entry-delimiter port))))))))))
(define (search-documentation-files name . files)(or-map(lambda(file)(find-documentation-in-file name file))(if(null? files)documentation-files files)))
(define(proc-doc proc)(or(procedure-documentation proc)(procedure-property proc(quote documentation))))
(define(object-documentation object)(or(and(procedure? object)(proc-doc object))(and(macro? object)(and=>(macro-transformer object)proc-doc))(object-property object(quote documentation))(and(procedure? object)(not(closure? object))(procedure-name object)(and=>(find-documentation(procedure-name object))(lambda(docstring)(set-procedure-property! object(quote documentation)docstring)docstring)))))
