(define-module(ice-9 md-data)#:export(all-keywords all-md-names md-by-name md-body-lookup extend-md-table!))
(define *keywords*(quote((#:magic . "string to be found at the beginning of a file"))))
(define(all-keywords)(list-copy *keywords*))
(define *md*(quasiquote((ELF #:magic(unquote(string #\ #\E #\L #\F)))(Mach-O-BE #:magic(unquote(list->string(map integer->char(quote(254 237 250 206)))))))))
(define(all-md-names)(map car *md*))
(define(md-by-name name)(assq-ref *md* name))
(define(md-body-lookup body kw)(let loop((ls body))(if(null? ls)#f(if(eq? kw(car ls))(cadr ls)(loop(cddr ls))))))
(define (extend-md-table! name . info)(cond((assq name *md*)=>(lambda(cell)(set-cdr! cell info)))(else(set! *md*(acons name info *md*)))))
