(define-module(ice-9 slib)#:use-module((ice-9 gumm)#:select(fob-locvar fob-defined? nested-ref save-module-excursion set-current-module unique-fob current-module eval-in-module))#:no-backtrace)
(define(eval-load <filename> evl)(if(not(file-exists? <filename>))(set! <filename>(string-append <filename>(scheme-file-suffix))))(call-with-input-file <filename>(lambda(port)(let((old-load-pathname *load-pathname*))(set! *load-pathname* <filename>)(do((o(read port)(read port)))((eof-object? o))(evl o))(set! *load-pathname* old-load-pathname)))))
(define slib:exit quit)
(define slib:error error)
(define slib:warn warn)
(define slib:eval(lambda(x)(eval-in-module x slib-module)))
(define defmacro:eval eval)
(define logical:logand logand)
(define logical:logior logior)
(define logical:logxor logxor)
(define logical:lognot lognot)
(define logical:ash ash)
(define logical:logcount logcount)
(define logical:integer-length integer-length)
(define logical:bit-extract bit-extract)
(define logical:integer-expt integer-expt)
(define logical:ipow-by-squaring ipow-by-squaring)
(define slib:eval-load eval-load)
(define slib:tab #\ht)
(define slib:form-feed #\np)
(define slib-module(current-module))
(define(defined? symbol)(fob-defined? slib-module symbol))
(define slib:features(append(quote(source eval abort alist defmacro delay dynamic-wind full-continuation hash hash-table line-i/o logical multiarg/and- multiarg-apply promise rev2-procedures rev4-optional-procedures string-port with-file))(if(defined?(quote getenv))(quote(getenv))(quote()))(if(defined?(quote current-time))(quote(current-time))(quote()))(if(defined?(quote system))(quote(system))(quote()))(if(defined?(quote array?))(quote(array))(quote()))(if(defined?(quote char-ready?))(quote(char-ready?))(quote()))(if(defined?(quote array-for-each))(quote(array-for-each))(quote()))(if(and(string->number "0.0")(inexact?(string->number "0.0")))(quote(inexact))(quote()))(if(rational?(string->number "1/19"))(quote(rational))(quote()))(if(real?(string->number "0.0"))(quote(real))())(if(complex?(string->number "1+i"))(quote(complex))(quote()))(let((n(string->number "9999999999999999999999999999999")))(if(and n(exact? n))(quote(bignum))(quote())))))
(define-public(slib:load name)(save-module-excursion(lambda()(set-current-module slib-module)(let((errinfo(catch(quote system-error)(lambda()(load-from-path name)#f)(lambda args args))))(if(and errinfo(catch(quote system-error)(lambda()(load-from-path(string-append name ".scm"))#f)(lambda args args)))(apply throw errinfo))))))
(define slib:load-source slib:load)
(define defmacro:load slib:load)
(define slib-parent-dir(let*((path(%search-load-path "slib/require.scm")))(if path(make-shared-substring path 0(-(string-length path)17))(error "Could not find slib/require.scm in " %load-path))))
(define-public(implementation-vicinity)(string-append slib-parent-dir "/"))
(define-public(library-vicinity)(string-append(implementation-vicinity)"slib/"))
(define-public home-vicinity(let((home-path(getenv "HOME")))(lambda()home-path)))
(define-public(scheme-implementation-type)(quote guile))
(define-public(scheme-implementation-version)"")
(define (output-port-width . arg) 80)
(define (output-port-height . arg) 24)
(define(identity x)x)
(define-public (make-random-state . args)(let((seed(if(null? args)*random-state*(car args))))(cond((string? seed))((number? seed)(set! seed(number->string seed)))(else(let()(require(quote object->string))(set! seed(object->limited-string seed 50)))))(seed->random-state seed)))
(define difftime -)
(define offset-time +)
(define %system-define define)
(define define(procedure->memoizing-macro(lambda(exp env)(if(=(length env)1)(quasiquote(define-public(unquote-splicing(cdr exp))))(quasiquote(%system-define(unquote-splicing(cdr exp))))))))
(define(hack!)(if(nested-ref(unique-fob #:root)(quote(%%app modules ice-9 syncase)))(set-object-property!(fob-locvar(current-module)(quote define))(quote *sc-expander*)(quote(define)))))
(hack!)
(define(software-type)"Return a symbol describing the current platform's operating system.\nThis may be one of AIX, VMS, UNIX, COHERENT, WINDOWS, MS-DOS, OS/2,\nTHINKC, AMIGA, ATARIST, MACH, or ACORN.\n\nNote that most varieties of Unix are considered to be simply \"UNIX\".\nThat is because when a program depends on features that are not present\non every operating system, it is usually better to test for the presence\nor absence of that specific feature.  The return value of\n@code{software-type} should only be used for this purpose when there is\nno other easy or unambiguous way of detecting such features."(quote UNIX))
(slib:load(in-vicinity(library-vicinity)"require.scm"))
(define-public require require:require)
(define *vicinity-table*(list(cons(quote implementation)(implementation-vicinity))(cons(quote library)(library-vicinity))))
(define(install-require-vicinity name vicinity)(let((entry(assq name *vicinity-table*)))(if entry(set-cdr! entry vicinity)(set! *vicinity-table*(acons name vicinity *vicinity-table*)))))
(define(install-require-module name vicinity-name file-name)(if(not *catalog*)(catalog:get(quote random)))(let((entry(assq name *catalog*))(vicinity(cdr(assq vicinity-name *vicinity-table*))))(let((path-name(in-vicinity vicinity file-name)))(if entry(set-cdr! entry path-name)(set! *catalog*(acons name path-name *catalog*))))))
