(define(uniform-vector? obj)(array? obj))
(define (make-uniform-vector length prototype . fill)(dimensions->uniform-array length prototype(if(null? fill)prototype(car fill))))
(define(uniform-vector-set! uve i obj)(uniform-array-set1! uve obj i))
(define(uniform-vector-fill! uve fill)(array-fill! uve fill))
(define uniform-vector-read! uniform-array-read!)
(define uniform-vector-write uniform-array-write)
(define (make-array fill . args)(dimensions->uniform-array args(quote())fill))
(define (make-uniform-array prot . args)(dimensions->uniform-array args prot))
(define(list->array ndim lst)(list->uniform-array ndim(quote())lst))
(define(list->uniform-vector prot lst)(list->uniform-array 1 prot lst))
(define(array-shape a)(map(lambda(ind)(if(number? ind)(list 0(+ -1 ind))ind))(array-dimensions a)))
(define(read:uniform-vector proto port)(if(eq? #\((peek-char port))(list->uniform-array 1 proto(read port))(error "read:uniform-vector list not found")))
(let((make-array-proc(lambda(template)(lambda(c port)(read:uniform-vector template port)))))(for-each(lambda(char template)(read-hash-extend char(make-array-proc template)))(quote(#\b #\a #\u #\e #\s #\i #\c #\y #\h #\l))(quote(#t #\a 1 -1 1.0 0.333333333333333 0.0+1.0i #\nul s l))))
(define(read:array digit port)(let*((chr0(char->integer #\0))(rank(let readnum((val(-(char->integer digit)chr0)))(if(char-numeric?(peek-char port))(readnum(+(* 10 val)(-(char->integer(read-char port))chr0)))val)))(prot(if(eq? #\((peek-char port))(quote())(let((c(read-char port)))(case c((#\b)#t)((#\a)#\a)((#\u)1)((#\e)-1)((#\s)1.0)((#\i)0.333333333333333)((#\c)0.0+1.0i)(else(error "read:array unknown option " c)))))))(if(eq?(peek-char port)#\()(list->uniform-array rank prot(read port))(error "read:array list not found"))))
(let*((beg(char->integer #\0))(end(+ beg 10)))(do((i beg(1+ i)))((= end i))(read-hash-extend(integer->char i)read:array)))
