(define-module(ice-9 editing-buffer)#:use-module((ice-9 gumm)#:select(eval-in-current-module-proc))#:use-module(ice-9 gap-buffer)#:export-syntax(editing-buffer))
(quote(#:use-module((ice-9 gap-buffer)#:renamer(lambda(sym)(let((e-3:ify(symbol-prefix-proc(quote e:)3)))(case sym((gb-point gb-point-min gb-point-max gb-bolp gb-eolp gb-bobp gb-eobp gb-goto-char gb-forward-char gb-backward-char gb-forward-line gb-beginning-of-line gb-end-of-line gb-match-string gb-looking-at gb-match-beginning gb-match-end gb-search-forward gb-re-search-forward gb-replace-match gb-insert gb-delete-region)(e-3:ify sym))((gb->string)(quote e:buffer-string))((gb->substring)(quote e:buffer-substring))((make-gap-buffer-port)(quote e:buffer-port))((md)(quote e:match-data))((md!)(quote e:set-match-data))((gb-delete-char!)(quote e:delete-char))((gb-erase!)(quote e:erase-buffer))((gb->port!)(quote e:write-to-port))(else sym)))))))
(define current-buffer-procs(quote()))
(define cb-count 0)
(define(register-cbproc! name)(set! current-buffer-procs(acons name cb-count current-buffer-procs))(set! cb-count(1+ cb-count)))
(defmacro FROM:gb args(quasiquote(use-modules((ice-9 gap-buffer)#:select(unquote args)))))
(define e:ify(symbol-prefix-proc(quote e:)))
(defmacro simple-gb->e: names(quasiquote(FROM:gb(unquote-splicing(map(lambda(name)(register-cbproc! name)(quasiquote((unquote(symbol-append(quote gb-)name))unquote(e:ify name))))names)))))
(defmacro tricky-gb->e: names(quasiquote(FROM:gb(unquote-splicing(map(lambda(gb/name)(let((name(cdr gb/name)))(register-cbproc! name)(quasiquote((unquote(car gb/name))unquote(e:ify name)))))names)))))
(simple-gb->e: toggle-read-only)
(simple-gb->e: point point-min point-max bolp eolp bobp eobp)
(tricky-gb->e: (gb->string . buffer-string) (gb->substring . buffer-substring) (make-gap-buffer-port . buffer-port))
(simple-gb->e: goto-char forward-char backward-char forward-line beginning-of-line end-of-line)
(tricky-gb->e: (md . match-data) (md! . set-match-data))
(simple-gb->e: match-string looking-at match-beginning match-end search-forward search-backward re-search-forward replace-match)
(simple-gb->e: insert)
(tricky-gb->e: (gb-delete-char! . delete-char) (gb-erase! . erase-buffer))
(simple-gb->e: delete-region)
(tricky-gb->e: (gb->port! . write-to-port))
(define *cbprocs*(let*((look(eval-in-current-module-proc))(->proc(lambda(x)(look(e:ify(car x))))))(list->vector(reverse!(map ->proc current-buffer-procs)))))
(define cbexp-specials(quote()))
(define(define-cbexp-special tag expander)(set! cbexp-specials(acons tag expander cbexp-specials)))
(define-cbexp-special(quote let)(lambda(box form)(let((expand-bindings(lambda(bindings-form)(map(lambda(binding)(quasiquote((unquote(car binding))(unquote-splicing(cbproc-app-expand box(cdr binding))))))bindings-form))))(if(not(pair?(cadr form)))(quasiquote((unquote(car form))(unquote(cadr form))(unquote(expand-bindings(caddr form)))(unquote-splicing(cbproc-app-expand box(cdddr form)))))(quasiquote((unquote(car form))(unquote(expand-bindings(cadr form)))(unquote-splicing(cbproc-app-expand box(cddr form)))))))))
(define-cbexp-special(quote let*)(assq-ref cbexp-specials(quote let)))
(define-cbexp-special(quote letrec)(assq-ref cbexp-specials(quote let)))
(define-cbexp-special(quote lambda)(lambda(box form)(quasiquote(lambda(unquote(cadr form))(unquote-splicing(cbproc-app-expand box(cddr form)))))))
(define-cbexp-special(quote define)(lambda(box form)(quasiquote(define(unquote(cadr form))(unquote-splicing(cbproc-app-expand box(cddr form)))))))
(define-cbexp-special(quote case)(lambda(box form)(quasiquote(case(unquote(cbproc-app-expand box(cadr form)))(unquote-splicing(map(lambda(case-element)(quasiquote((unquote(car case-element))(unquote-splicing(cbproc-app-expand box(cdr case-element))))))(cddr form)))))))
(define-cbexp-special(quote current-buffer)(lambda(box form)(car box)))
(define(newname<-prefix+idx prefix idx)(string->symbol(simple-format #f "~A/~A" prefix idx)))
(define(cbproc-app-expand box form)(cond((pair? form)(let((op(car form))(handle-rest(lambda()(cond((not(list? form))(cbproc-app-expand box(cdr form)))((= 1(length form))(quote()))(else(map(lambda(elem)(cbproc-app-expand box elem))(cdr form)))))))(cond((assq-ref cbexp-specials op)=>(lambda(expand)(expand box form)))((assq-ref current-buffer-procs op)=>(lambda(idx)(or(assq-ref(cdr box)op)(set-cdr! box(acons op idx(cdr box))))(quasiquote((unquote(newname<-prefix+idx(car box)idx))(unquote(car box))(unquote-splicing(handle-rest))))))(else(cons(cbproc-app-expand box op)(handle-rest))))))(else form)))
(define-macro (editing-buffer buffer . body)(let*((bufsym(gensym))(symbox(list bufsym))(bigbod(cbproc-app-expand symbox body))(prdefs(map(lambda(pair)(let((op(car pair))(idx(cdr pair)))(quasiquote((unquote(newname<-prefix+idx bufsym idx))(unquote(vector-ref *cbprocs* idx))))))(cdr symbox)))(v(quasiquote(let*(((unquote bufsym)(let((init(unquote buffer)))(cond(((unquote gb?)init)init)((eq? #t init)((unquote make-gap-buffer)))(else((unquote make-gap-buffer)init)))))(unquote-splicing prdefs))(unquote bufsym)(unquote-splicing bigbod)))))v))
