(define-module(ice-9 expect)#:use-module(ice-9 regex))
(define-public expect-port #f)
(define-public expect-timeout #f)
(define-public expect-timeout-proc #f)
(define-public expect-eof-proc #f)
(define-public expect-char-proc #f)
(defmacro-public expect clauses(let((s(gentemp))(c(gentemp))(port(gentemp))(timeout(gentemp)))(quasiquote(let(((unquote s)"")((unquote port)(or expect-port(current-input-port)))((unquote timeout)(if expect-timeout(let*((secs-usecs(gettimeofday)))(+(car secs-usecs)expect-timeout(/(cdr secs-usecs)1000000)))#f)))(let next-char()(if(and expect-timeout(not(expect-select(unquote port)(unquote timeout))))(if expect-timeout-proc(expect-timeout-proc(unquote s))#f)(let(((unquote c)(read-char(unquote port))))(if expect-char-proc(expect-char-proc(unquote c)))(if(not(eof-object?(unquote c)))(set!(unquote s)(string-append(unquote s)(string(unquote c)))))(cond(unquote-splicing(let next-expr((tests(map car clauses))(exprs(map cdr clauses))(body(quote())))(cond((null? tests)(reverse body))(else(next-expr(cdr tests)(cdr exprs)(cons(quasiquote(((unquote(car tests))(unquote s)(eof-object?(unquote c)))(unquote-splicing(cond((null?(car exprs))(quote()))((eq?(caar exprs)(quote =>))(if(not(=(length(car exprs))2))(scm-error(quote misc-error)"expect" "bad recipient: ~S"(list(car exprs))#f)(quasiquote((apply(unquote(cadar exprs))((unquote(car tests))(unquote s)(unquote port)))))))(else(car exprs))))))body))))))(else(cond((eof-object?(unquote c))(if expect-eof-proc(expect-eof-proc(unquote s))#f))(else(next-char))))))))))))
(define-public expect-strings-compile-flags regexp/newline)
(define-public expect-strings-exec-flags regexp/noteol)
(defmacro-public expect-strings clauses(quasiquote(let(unquote-splicing(let next-test((tests(map car clauses))(exprs(map cdr clauses))(defs(quote()))(body(quote())))(cond((null? tests)(list(reverse defs)(quasiquote(expect(unquote-splicing(reverse body))))))(else(let((rxname(gentemp)))(next-test(cdr tests)(cdr exprs)(cons(quasiquote((unquote rxname)(make-regexp(unquote(car tests))expect-strings-compile-flags)))defs)(cons(quasiquote((lambda(s eof?)(expect-regexec(unquote rxname)s eof?))(unquote-splicing(car exprs))))body))))))))))
(define-public(expect-select port timeout)(let*((secs-usecs(gettimeofday))(relative(- timeout(car secs-usecs)(/(cdr secs-usecs)1000000))))(and(> relative 0)(pair?(car(select(list port)(quote())(quote())relative))))))
(define-public(expect-regexec rx s eof?)(let*((flags(if(and eof?(logand expect-strings-exec-flags regexp/noteol))(logxor expect-strings-exec-flags regexp/noteol)expect-strings-exec-flags))(match(regexp-exec rx s 0 flags)))(if match(do((i(-(match:count match)1)(- i 1))(result(quote())(cons(match:substring match i)result)))((< i 0)result))#f)))
