(or(provided?(quote threads))(error "no code for module (ice-9 threads)"))
(define-module(ice-9 threads)#:use-module(ice-9 threads-sup))
(export %thread-handler)
(define (%thread-handler tag . args)(fluid-set! the-last-stack #f)(unmask-signals)(let((n(length args))(p(current-error-port)))(display "In thread:" p)(newline p)(if(>= n 3)(display-error #f p(car args)(cadr args)(caddr args)(if(= n 4)(cadddr args)(quote())))(begin(display "uncaught throw to " p)(display tag p)(display ": " p)(display args p)(newline p)))))
(defmacro-public make-thread (proc . args)(quasiquote(call-with-new-thread(lambda()((unquote proc)(unquote-splicing args)))%thread-handler)))
(defmacro-public begin-thread (first . rest)(quasiquote(call-with-new-thread(lambda()(begin(unquote first)(unquote-splicing rest)))%thread-handler)))
(defmacro-public with-mutex (m . body)(quasiquote(dynamic-wind(lambda()(lock-mutex(unquote m)))(lambda()(begin(unquote-splicing body)))(lambda()(unlock-mutex(unquote m))))))
(defmacro-public monitor (first . rest)(quasiquote(with-mutex(unquote(make-mutex))(begin(unquote first)(unquote-splicing rest)))))
